// Karma configuration file, see link for more information
// https://karma-runner.github.io/1.0/config/configuration-file.html

module.exports = function (config) {
  config.set({
    basePath: '.',
    frameworks: ['jasmine', '@angular-devkit/build-angular'],
    plugins: [
      require('karma-jasmine'),
      require('karma-chrome-launcher'),
      require('karma-jasmine-html-reporter'),
      require('karma-coverage'),
      require('@angular-devkit/build-angular/plugins/karma')
    ],
    files: [
      {pattern: 'test/data/**/*.json', included: false, served: true},
      { pattern: './node_modules/jquery/dist/jquery.min.js', watched: false },
      { pattern: './node_modules/zone.js/dist/zone.min.js', watched: false }
    ],
    client: {
      clearContext: false // leave Jasmine Spec Runner output visible in browser
    },
    coverageIstanbulReporter: {
      dir: require('path').join(__dirname, './coverage/lforms'),
      reports: ['html', 'lcovonly', 'text-summary'],
      fixWebpackSourcePaths: true
    },
    reporters: ['progress', 'kjhtml'],
    port: 9876,
    colors: true,
    logLevel: config.LOG_INFO,
    autoWatch: true,
    browsers: ['ChromeHeadless_without_password_security'],
    customLaunchers: {
      ChromeHeadless_without_password_security: {
        base: 'ChromeHeadless',
        flags: ['--password-store=basic']
      },
    },
    singleRun: true,
    listenAddress: 'localhost', // binds the test server to localhost
    restartOnFileChange: true
  });
};
